﻿using NAudio.Wave;

namespace Bmp.Core.Lite.Playback.MiddleWare;

public class VisualizeDataEventArgs : EventArgs
{
    public WaveFormat Format { get; }
    public ReadOnlyMemory<byte> Bytes { get; }

    public VisualizeDataEventArgs(WaveFormat format, ReadOnlyMemory<byte> bytes)
    {
        Format = format;
        Bytes = bytes;
    }
}