﻿using System.Runtime.InteropServices;

namespace Bmp.Core.FFMpeg.CsCorePorts.FFMpegWrap.Interops;

internal class ConstCharPtrMarshaler : ICustomMarshaler
{
    public object MarshalNativeToManaged(nint pNativeData)
    {
        return Marshal.PtrToStringAnsi(pNativeData);
    }

    public nint MarshalManagedToNative(object managedObj)
    {
        return nint.Zero;
    }

    public void CleanUpNativeData(nint pNativeData)
    {
    }

    public void CleanUpManagedData(object managedObj)
    {
    }

    public int GetNativeDataSize()
    {
        return nint.Size;
    }

    private static readonly ConstCharPtrMarshaler Instance = new ConstCharPtrMarshaler();

    public static ICustomMarshaler GetInstance(string cookie)
    {
        return Instance;
    }
}