﻿
namespace Bmp.WinForms.SaveLoad.Models;

internal class SaveLoadState
{
    public Point? FormPosition { get; set; }
    public Size? FormSize { get; set; }

    public string? SelectedPcmOutputDeviceId { get; set; }
    public string? SelectedDsdAsioOutputDeviceId { get; set; }
    public int? OutputDeviceLatency { get; set; }

    public bool DecodeDsdToPcm { get; set; }

    public IReadOnlyCollection<SaveLoadPlaylistItem>? Playlist { get; set; }
    public PlaylistMode PlaylistMode { get; set; }
}
